## crust-firmware 0.4

=== drivers/Makefile ===
#
# Copyright © 2017-2021 The Crust Firmware Authors.
# SPDX-License-Identifier: BSD-3-Clause OR GPL-2.0-only
#

obj-$(CONFIG_CIR) += cir/
obj-y += clock/
obj-y += css/
obj-y += dram/
obj-y += gpio/
obj-y += irq/
obj-y += mfd/
obj-y += msgbox/
obj-y += pmic/
obj-y += regmap/
obj-y += regulator/
obj-$(CONFIG_SERIAL) += serial/
obj-y += watchdog/

=== drivers/dram/Makefile ===
#
# Copyright © 2017-2021 The Crust Firmware Authors.
# SPDX-License-Identifier: BSD-3-Clause OR GPL-2.0-only
#

obj-y += dram.o

obj-$(CONFIG_PLATFORM_A64) += sun8i-h3-dram.o
obj-$(CONFIG_PLATFORM_H6)  += sun50i-h6-dram.o

=== debian/changelog ===
crust-firmware (0.4-1) experimental; urgency=medium

  [ upstream ]
  * new release

  [ Arnaud Ferraris ]
  * add patch 0001 to support PineTab

  [ Nicolas Boulenguez ]
  * update metadata for patch 0001

  [ Jonas Smedegaard ]
  * fix exclude upstream git-ignore hints from source git
  * copyright info:
    + add Licence-Grant fields
    + use Licence-Reference field;
      override lintian (see bug#786450)
    + add source helper script copyright-check

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 05 Jun 2021 13:38:18 +0200

crust-firmware (0.3-2) experimental; urgency=medium

  [ Nicolas Boulenguez ]
  * set Multi-Arch: foreign,
    allowing an accurate list of build-dependencies for the u-boot package
    closes: Bug#988257, thanks to Vagrant Cascadian

  [ Jonas Smedegaard ]
  * add git-buildpackage settings to source package

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 11 May 2021 17:00:53 +0200

crust-firmware (0.3-1) experimental; urgency=medium

  * Initial packaging. Closes: #979326.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 21 Dec 2020 07:50:27 +0000

=== debian/control ===
Source: crust-firmware
Section: admin
Priority: optional
Maintainer: Nicolas Boulenguez <nicolas@debian.org>
Uploaders:
 Jonas Smedegaard <dr@jones.dk>,
 Arnaud Ferraris <arnaud.ferraris@gmail.com>,
Standards-Version: 4.5.1
Build-Depends:
 bison,
 debhelper-compat (= 13),
 flex,
 gcc-or1k-elf,
Rules-Requires-Root: no
Homepage: https://github.com/crust-firmware/crust
Vcs-Browser: https://salsa.debian.org/debian/crust-firmware
Vcs-Git: https://salsa.debian.org/debian/crust-firmware.git

Package: crust-firmware
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: SCP firmware for Allwinner sunxi boards
 Some System on a Chip (SoC) computers, also known as single-board,
 embed a dedicated processor called a System Control Processor (SCP)
 which abstracts power and system management tasks away from
 application processors.
 .
 Crust replaces the proprietary firmware on the Allwinner's AR100 SCP,
 found in sunxi boards like Banana/Orange/Lichee Pi or Pinebook/phone.
 .
 There is usually no need to install this package.  The same contents
 are more conveniently available from the u-boot-sunxi package.

=== debian/rules ===
#!/usr/bin/make -f

verbose := $(if $(filter terse,$(DEB_BUILD_OPTIONS)),,V=1)

# Arnaud Ferraris <arnaud.ferraris@gmail.com>
platforms += pinephone pinetab

# Vagrant Cascadian <vagrant@debian.org>
platforms += pinebook pine64_plus

%:
	dh $@

override_dh_auto_build: $(platforms)
$(platforms):
	dh_auto_build -- $(verbose) TGT=build/$@ $@_defconfig
	dh_auto_build -- $(verbose) TGT=build/$@ CROSS_COMPILE=or1k-elf- scp
  # Remove execution permissions set by GCC.
  # Move to the parent directory for easyer installation.
  # Rename the binary file after the platform.
	install -m644 build/$@/scp.bin build/$@.bin

=== debian/watch ===
version=4

opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/crust-$1\.tar\.gz/ \
  https://github.com/crust-firmware/crust/tags .*/v?(\d\S+)\.tar\.gz

## crust-firmware 0.5

=== Makefile ===
#
# Copyright © 2017-2021 The Crust Firmware Authors.
# SPDX-License-Identifier: BSD-3-Clause OR GPL-2.0-only
#

SRC		 = .
OBJ		 = build
TGT		 = $(OBJ)/scp

BUILDAR		 = ar
BUILDCC		 = cc

HOST_COMPILE	?= aarch64-linux-musl-
HOSTAR		 = $(HOST_COMPILE)gcc-ar
HOSTCC		 = $(HOST_COMPILE)gcc

AR		 = $(CROSS_COMPILE)gcc-ar
CC		 = $(CROSS_COMPILE)gcc
OBJCOPY		 = $(CROSS_COMPILE)objcopy

LEX		 = lex
YACC		 = bison

COMMON_CFLAGS	 = -Os -pipe -std=c11 \
		   -fdata-sections \
		   -ffunction-sections \
		   -fno-builtin \
		   -fno-common \
		   -fvar-tracking-assignments \
		   -g$(if $(CONFIG_DEBUG_INFO),gdb,0) \
		   -Wall -Wextra -Wformat=2 -Wpedantic -Wshadow \
		   -Werror=implicit-function-declaration \
		   -Werror=implicit-int \
		   -Werror=pointer-arith \
		   -Werror=pointer-sign \
		   -Werror=strict-prototypes \
		   -Werror=undef \
		   -Werror=vla \
		   -Wno-missing-field-initializers
COMMON_CPPFLAGS	 = -I$(OBJ)/include \
		   -I$(SRC)/platform/$(CONFIG_PLATFORM)/include \
		   -I$(SRC)/arch/$(CONFIG_ARCH)/include \
		   -I$(SRC)/include/common \
		   -I$(SRC)/include/lib

HEADERS		 = $(OBJ)/include/config.h \
		   $(SRC)/lib/compiler.h \
		   $(SRC)/lib/kconfig.h

BUILDCFLAGS	 = $(COMMON_CFLAGS)
BUILDCPPFLAGS	 = $(COMMON_CPPFLAGS) \
		   -D_XOPEN_SOURCE=700
BUILDLDFLAGS	 =
BUILDLDLIBS	 =

HOSTCFLAGS	 = $(COMMON_CFLAGS) \
		   -Werror=implicit-fallthrough=5
HOSTCPPFLAGS	 = $(COMMON_CPPFLAGS) \
		   -D_XOPEN_SOURCE=700
HOSTLDFLAGS	 =
HOSTLDLIBS	 =

AFLAGS		 = -Wa,--fatal-warnings
CFLAGS		 = $(COMMON_CFLAGS) \
		   -ffreestanding \
		   -flto \
		   -fno-asynchronous-unwind-tables \
		   -fno-pie \
		   -fomit-frame-pointer \
		   -funsigned-char \
		   -Werror=implicit-fallthrough=5
CPPFLAGS	 = $(COMMON_CPPFLAGS) \
		   -I$(SRC)/include/drivers \
		   -I$(SRC)/include/stdlib \
		   $(foreach header,$(HEADERS),-include $(notdir $(header))) \
		   -nostdinc \
		   -Werror=missing-include-dirs
LDFLAGS		 = -nostdlib \
		   -no-pie \
		   -static \
		   -Wl,-O1 \
		   -Wl,--build-id=none \
		   -Wl,--fatal-warnings \
		   -Wl,--gc-sections \
		   -Wl,--no-dynamic-linker \
		   -Wl,--no-undefined

###############################################################################

.DEFAULT_GOAL	:= all
GOALS		:= $(if $(MAKECMDGOALS),$(MAKECMDGOALS),$(.DEFAULT_GOAL))
MAKEFLAGS	+= -Rr

DOCS		 = $(wildcard $(SRC)/*.md $(SRC)/docs/*.md)
OBJ_DEPS	 = $(OBJ)/include/version.h

export KCONFIG_AUTOCONFIG := $(OBJ)/include/config/auto.conf
export KCONFIG_AUTOHEADER := $(OBJ)/include/config.h

ifneq ($(filter-out %clean %clobber %config %format,$(GOALS)),)
  include $(OBJ)/include/config/auto.conf
  include $(OBJ)/include/config/auto.conf.cmd
endif

include $(SRC)/scripts/Makefile.format
include $(SRC)/scripts/Makefile.kbuild

$(call descend,3rdparty arch common drivers lib tools)

###############################################################################

M := @$(if $(filter-out 0,$(V)),:,exec printf '  %-7s %s\n')
Q :=  $(if $(filter-out 0,$(V)),,@)exec

all: scp tools $(test-all)

check: $(test-all:%=%.test)

clean:
	$(Q) rm -fr $(TGT)

clobber:
	$(Q) rm -fr $(OBJ)

distclean:
	$(Q) rm -fr $(OBJ) ..config* .config*

html: $(OBJ)/docs

scp: $(TGT)/scp.bin

tools: $(tools-all)

.config:;

%/.:
	$(Q) mkdir -p $*

%.d:;

$(OBJ)/docs: $(OBJ)/Doxyfile $(DOCS) $(obj-all)
	$(M) DOXYGEN $@
	$(Q) doxygen $<
	$(Q) touch $@

$(OBJ)/Doxyfile: $(SRC)/Doxyfile
	$(Q) sed 's|@DOCS@|$(DOCS)|g;s|@OBJ@|$(OBJ)|g;s|@SRC@|$(SRC)|g' $< > $@

$(OBJ)/%.test: $(SRC)/scripts/test.sh $(OBJ)/%
	$(M) TEST $@
	$(Q) $^ $@

$(OBJ)/%: $(OBJ)/%.o
	$(M) HOSTLD $@
	$(Q) $(HOSTCC) $(HOSTCFLAGS) $(HOSTLDFLAGS) -o $@ $^ $(HOSTLDLIBS)

$(test-all): $(OBJ)/lib.a
$(tools-all): $(OBJ)/lib.a

$(OBJ)/lib.a:
	$(M) HOSTAR $@
	$(Q) $(HOSTAR) Drcs $@ $^

$(OBJ)/%.o: $(OBJ)/%.c
	$(M) HOSTCC $@
	$(Q) $(HOSTCC) $(HOSTCPPFLAGS) $(HOSTCFLAGS) -MMD -c -o $@ $<

$(OBJ)/%.o: $(SRC)/%.c
	$(M) HOSTCC $@
	$(Q) $(HOSTCC) $(HOSTCPPFLAGS) $(HOSTCFLAGS) -MMD -c -o $@ $<

$(OBJ)/%.lex.c: $(SRC)/%.l
	$(M) LEX $@
	$(Q) $(LEX) -o $@ $<

$(OBJ)/%.tab.c $(OBJ)/%.tab.h: $(SRC)/%.y
	$(M) YACC $@
	$(Q) $(YACC) -d -t -o $@ $<

$(OBJ)/include/config.h: $(OBJ)/include/config/auto.conf;

$(OBJ)/include/config/auto.conf: $(OBJ)/3rdparty/kconfig/conf .config
	$(M) GEN $@
	$(Q) $< --syncconfig $(SRC)/Kconfig

$(OBJ)/include/config/auto.conf.cmd: $(OBJ)/include/config/auto.conf;

$(OBJ)/include/version.h: $(SRC)/scripts/version.sh FORCE | $(OBJ)/include/.
	$(Q) $< $(realpath $(SRC)) $@

$(TGT)/%.bin: $(TGT)/%.elf
	$(M) OBJCOPY $@
	$(Q) $(OBJCOPY) -O binary -S --reverse-bytes 4 $< $@

$(TGT)/%.elf $(TGT)/%.map: $(obj-all) $(TGT)/lib.a
	$(M) LD $@
	$(Q) $(CC) $(CFLAGS) $(LDFLAGS) -Wl,-Map,$(TGT)/$*.map -o $@ -T $^

$(TGT)/lib.a:
	$(M) AR $@
	$(Q) $(AR) Drcs $@ $^

$(TGT)/%.o: $(SRC)/%.c
	$(M) CC $@
	$(Q) $(CC) $(CPPFLAGS) $(CFLAGS) $(AFLAGS) -MMD -c -o $@ $<

$(TGT)/%.o: $(SRC)/%.S
	$(M) AS $@
	$(Q) $(CC) $(CPPFLAGS) $(AFLAGS) -MMD -c -o $@ $<

$(TGT)/%.ld.o: $(SRC)/%.ld.S
	$(M) CPP $@
	$(Q) $(CC) $(CPPFLAGS) -E -MMD -MT $@ -P -o $@ $<

$(SRC)/Makefile:;
$(SRC)/%.h:;

.PHONY: FORCE all check clean clobber distclean doc scp tools
.SECONDARY:
.SUFFIXES:

=== 3rdparty/Makefile ===
#
# Copyright © 2017-2021 The Crust Firmware Authors.
# SPDX-License-Identifier: BSD-3-Clause OR GPL-2.0-only
#

hostprogs-y += kconfig/

=== arch/Makefile ===
#
# Copyright © 2020-2021 The Crust Firmware Authors.
# SPDX-License-Identifier: BSD-3-Clause OR GPL-2.0-only
#

obj-$(CONFIG_ARCH_OR1K) += or1k/

=== common/Makefile ===
#
# Copyright © 2017-2021 The Crust Firmware Authors.
# SPDX-License-Identifier: BSD-3-Clause OR GPL-2.0-only
#

obj-y += debug/

obj-y += debug.o
obj-y += delay.o
obj-y += device.o
obj-y += regulator_list.o
obj-y += scpi.o
obj-y += scpi_cmds.o
obj-y += simple_device.o
obj-y += system.o
obj-y += timeout.o

=== drivers/Makefile ===
--- 
+++ 
@@ -3,6 +3,7 @@
 # SPDX-License-Identifier: BSD-3-Clause OR GPL-2.0-only
 #
 
+obj-$(CONFIG_CEC) += cec/
 obj-$(CONFIG_CIR) += cir/
 obj-y += clock/
 obj-y += css/

=== lib/Makefile ===
#
# Copyright © 2017-2021 The Crust Firmware Authors.
# SPDX-License-Identifier: BSD-3-Clause OR GPL-2.0-only
#

lib-y += bitfield.o

=== tools/Makefile ===
#
# Copyright © 2017-2021 The Crust Firmware Authors.
# SPDX-License-Identifier: BSD-3-Clause OR GPL-2.0-only
#

tools-y += load
tools-y += test

=== 3rdparty/kconfig/Makefile ===
#
# Copyright © 2017-2021 The Crust Firmware Authors.
# SPDX-License-Identifier: GPL-2.0-only
#
# Based in part on scripts/kconfig/Makefile from Linux v4.19.
#

ccflags-y	+= -D_GNU_SOURCE \
		   -std=gnu11 \
		   -Wno-implicit-fallthrough \
		   -Wno-pedantic \
		   -Wno-sign-compare \
		   -Wno-unused-parameter \
		   -Wno-vla
cppflags-y	+= -I$(src)

BUILDCFLAGS_nconf := $(shell \
	pkg-config --cflags menuw panelw ncursesw 2>/dev/null \
	|| pkg-config --cflags menu panel ncurses 2>/dev/null \
	|| echo "-D_GNU_SOURCE -I/usr/include/ncurses")
BUILDLDLIBS_nconf := $(shell \
	pkg-config --libs menuw panelw ncursesw 2>/dev/null \
	|| pkg-config --libs menu panel ncurses 2>/dev/null \
	|| echo "-lmenu -lpanel -lncurses")

buildprogs-y	+= conf nconf
common-objs	:= confdata.o expr.o lexer.lex.o parser.tab.o \
		   preprocess.o symbol.o util.o
conf-objs	:= $(common-objs) conf.o
nconf-objs	:= $(common-objs) nconf.o nconf.gui.o

silent := $(if $(filter-out 0,$(V)),,-s)

# These targets map 1:1 to the command line options of 'conf'.
simple-targets := \
	alldefconfig allnoconfig allyesconfig helpnewconfig listnewconfig \
	oldconfig olddefconfig randconfig syncconfig

$(simple-targets): $(obj)/conf
	$(Q) $< $(silent) --$@ $(SRC)/Kconfig

config: $(obj)/conf
	$(Q) $< $(silent) --oldaskconfig $(SRC)/Kconfig

defconfig: $(obj)/conf
	$(Q) $< $(silent) --defconfig=$(SRC)/configs/$@ $(SRC)/Kconfig

%_defconfig: $(obj)/conf
	$(Q) $< $(silent) --defconfig=$(SRC)/configs/$@ $(SRC)/Kconfig

nconfig: $(obj)/nconf
	$(Q) $< $(silent) $(SRC)/Kconfig

savedefconfig: $(obj)/conf
	$(Q) $< $(silent) --$@=defconfig $(SRC)/Kconfig

$(obj)/lexer.lex.c: | $(obj)/.
$(obj)/lexer.lex.o: $(obj)/parser.tab.c
$(obj)/parser.tab.c: | $(obj)/.

.PHONY: $(simple-targets) config defconfig %_defconfig nconfig savedefconfig

=== arch/or1k/Makefile ===
#
# Copyright © 2020-2021 The Crust Firmware Authors.
# SPDX-License-Identifier: BSD-3-Clause OR GPL-2.0-only
#

CROSS_COMPILE	?= or1k-linux-musl-
CFLAGS		+= -ffixed-r2 \
		   -msfimm -mshftimm -msoft-div -msoft-mul

# The first object is used as the linker script.
obj-y += scp.ld.o

obj-y += counter.o
obj-y += exception.o
obj-y += math.o
obj-y += runtime.o
obj-y += start.o

=== common/debug/Makefile ===
#
# Copyright © 2020-2021 The Crust Firmware Authors.
# SPDX-License-Identifier: BSD-3-Clause OR GPL-2.0-only
#

obj-$(CONFIG_DEBUG_MONITOR)       += monitor.o
obj-$(CONFIG_DEBUG_PRINT_BATTERY) += battery.o
obj-$(CONFIG_DEBUG_PRINT_LATENCY) += latency.o
obj-$(CONFIG_DEBUG_PRINT_SPRS)    += sprs.o
obj-$(CONFIG_DEBUG_RECORD_STEPS)  += steps.o
obj-$(CONFIG_DEBUG_VERIFY_DRAM)   += dram.o

=== drivers/cec/Makefile ===
#
# Copyright © 2021 The Crust Firmware Authors.
# SPDX-License-Identifier: BSD-3-Clause OR GPL-2.0-only
#

obj-y += cec.o

obj-y += dw-hdmi-cec.o

=== drivers/cir/Makefile ===
#
# Copyright © 2020-2021 The Crust Firmware Authors.
# SPDX-License-Identifier: BSD-3-Clause OR GPL-2.0-only
#

obj-y += cir.o

obj-$(CONFIG_CIR_PROTO_NEC)  += nec.o
obj-$(CONFIG_CIR_PROTO_NECX) += nec.o
obj-$(CONFIG_CIR_PROTO_RC6)  += rc6.o

obj-y += sunxi-cir.o

=== debian/changelog ===
crust-firmware (0.5-3) unstable; urgency=medium

  * Standards-Version: 4.6.2.

  [ Jelmer Vernooĳ <jelmer@debian.org> ]
  * Update lintian override info format in d/source/lintian-overrides on line
    2-5.
  * Set upstream metadata fields: Bug-Submit, Repository-Browse, Repository.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 22 Dec 2022 15:17:54 +0000

crust-firmware (0.5-2) unstable; urgency=medium

  [ Jonas Smedegaard ]
  * note Philip Rinn as tester in source

  * Link with --no-warn-rwx-segments. Closes: #1015057
  * watch: remove unneeded filenamemangle option
  * upstream/metadata: basic information about upstream contacts
  * generic_platforms.patch: not forwarded
  * Standards-Version: 4.6.1
  * fix lintian override for wrong-section-according-to-package-name
  * Update copyright years

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 04 Aug 2022 12:43:57 +0200

crust-firmware (0.5-1) unstable; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * update watch file:
    + fix and gneralize filename mangling
    + set (currently unused) dversionmangle=auto
    + use substitution strings
  * add patch 2001 to add configs for generic platforms
  * build generic A64 targets,
    and symlink those for each specific platforms
  * enable platforms a64-olinuxino a64-olinuxino-emmc pine64-lts,
    and mention potential testers in source
  * add README.Debian,
    covering linux cmdline option clk_ignore_unused
  * enable cec module
    for platforms with seemingly fully wired HDMI connector
    (notably omitting pinebook and teres_i);
    document HDMI CEC and serial port support in README.Debian

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 16 Nov 2021 19:25:55 +0100

crust-firmware (0.4-3) unstable; urgency=medium

  [ Nicolas Boulenguez ]
  * update copyright info: update lintian overrides

  [ Jonas Smedegaard ]
  * drop patch 0001,
    and instead reuse identically compiled pinebook binary
  * reuse pinebook binary for teres_i
  * update copyright info:
    + add preferred upstream contact
  * update copyright info: use Reference field (not License-Reference)

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 07 Oct 2021 22:43:08 +0200

crust-firmware (0.4-2) unstable; urgency=medium

  [ Jonas Smedegaard ]
  * watch file: add usage comment
  * declare compliance with Debian Policy 4.6.0
  * improve source helper script copyright-check

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 06 Sep 2021 21:25:26 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders:
  Jonas Smedegaard <dr@jones.dk>,
  Arnaud Ferraris <arnaud.ferraris@gmail.com>,
-Standards-Version: 4.5.1
+Standards-Version: 4.6.2
 Build-Depends:
  bison,
  debhelper-compat (= 13),

=== debian/rules ===
#!/usr/bin/make -f

verbose := $(if $(filter terse,$(DEB_BUILD_OPTIONS)),,V=1)

platforms = $(foreach p, a64 a64_axp20x a64_axp20x_cec,\
 generic_$p generic_$p_no-serial)

# Jonas Smedegaard <dr@jones.dk>
# maybe Rodrigo Exterckötter Tjäder <rodrigo@tjader.xyz>
platforms_like_generic_a64_axp20x_cec += a64-olinuxino

# Jonas Smedegaard <dr@jones.dk>
# Philip Rinn <rinni@inventati.org>
platforms_like_generic_a64_axp20x_cec += a64-olinuxino-emmc

# Sunil Mohan Adapa <sunil@medhas.org>
platforms_like_generic_a64_axp20x_cec += pine64-lts

# Vagrant Cascadian <vagrant@debian.org>
platforms_like_generic_a64_axp20x_cec += pine64_plus

# Vagrant Cascadian <vagrant@debian.org>
platforms_like_generic_a64_axp20x_no-serial += pinebook

# Arnaud Ferraris <arnaud.ferraris@gmail.com>
# maybe Arnaud Ferraris <arnaud.ferraris@collabora.com> (1.1, 1.2)
# maybe Benoit Delcour <benoit.delcour@gmail.com> (1.2)
platforms_like_generic_a64_axp20x_no-serial += pinephone

# Arnaud Ferraris <arnaud.ferraris@gmail.com>
platforms_like_generic_a64_axp20x_no-serial += pinetab

# Jonas Smedegaard <dr@jones.dk>
platforms_like_generic_a64_axp20x_no-serial += teres_i

%:
	dh $@

# create most generic config, not possible to contain in patch
execute_before_dh_auto_build:
	touch configs/generic_a64_defconfig

override_dh_auto_build: $(platforms)
$(platforms):
	dh_auto_build -- $(verbose) TGT=build/$@ $@_defconfig
	dh_auto_build -- $(verbose) TGT=build/$@ CROSS_COMPILE=or1k-elf- scp
  # Remove execution permissions set by GCC.
  # Move to the parent directory for easyer installation.
  # Rename the binary file after the platform.
	install -m644 build/$@/scp.bin build/$@.bin

override_dh_link:
	dh_link -- $(foreach source,$(platforms),\
		$(foreach target,$(platforms_like_$(source)),\
			usr/lib/crust-firmware/$(source).bin usr/lib/crust-firmware/$(target).bin))

=== debian/watch ===
version=4
# check: uscan --report
# update: gbp import-orig --upstream-vcs-tag=vX.Y.Z --uscan

opts=\
dversionmangle=auto \
https://github.com/crust-firmware/crust/tags \
.*?@ANY_VERSION@@ARCHIVE_EXT@

## crust-firmware 0.6

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright © 2017-2021 The Crust Firmware Authors.
+# Copyright © 2017-2022 The Crust Firmware Authors.
 # SPDX-License-Identifier: BSD-3-Clause OR GPL-2.0-only
 #
 
@@ -8,7 +8,7 @@
 TGT		 = $(OBJ)/scp
 
 BUILDAR		 = ar
-BUILDCC		 = cc
+BUILDCC		?= cc
 
 HOST_COMPILE	?= aarch64-linux-musl-
 HOSTAR		 = $(HOST_COMPILE)gcc-ar
@@ -16,6 +16,7 @@
 
 AR		 = $(CROSS_COMPILE)gcc-ar
 CC		 = $(CROSS_COMPILE)gcc
+LD		 = $(shell $(CC) -print-prog-name=ld)
 OBJCOPY		 = $(CROSS_COMPILE)objcopy
 
 LEX		 = lex
@@ -60,7 +61,8 @@
 HOSTLDFLAGS	 =
 HOSTLDLIBS	 =
 
-AFLAGS		 = -Wa,--fatal-warnings
+AFLAGS		 = -Wa,--fatal-warnings \
+		   -Wa,--noexecstack
 CFLAGS		 = $(COMMON_CFLAGS) \
 		   -ffreestanding \
 		   -flto \
@@ -83,7 +85,10 @@
 		   -Wl,--fatal-warnings \
 		   -Wl,--gc-sections \
 		   -Wl,--no-dynamic-linker \
-		   -Wl,--no-undefined
+		   -Wl,--no-undefined \
+		   $(call ld-option,--no-warn-rwx-segments)
+
+ld-option	 = $(shell $(LD) -v $1 >/dev/null 2>&1 && printf '%s' '-Wl,$1')
 
 ###############################################################################
 
@@ -112,7 +117,7 @@
 M := @$(if $(filter-out 0,$(V)),:,exec printf '  %-7s %s\n')
 Q :=  $(if $(filter-out 0,$(V)),,@)exec
 
-all: scp tools $(test-all)
+all: scp $(test-all)
 
 check: $(test-all:%=%.test)

=== 3rdparty/Makefile ===
#
# Copyright © 2017-2022 The Crust Firmware Authors.
# SPDX-License-Identifier: BSD-3-Clause OR GPL-2.0-only
#

hostprogs-y += kconfig/

=== arch/Makefile ===
#
# Copyright © 2020-2022 The Crust Firmware Authors.
# SPDX-License-Identifier: BSD-3-Clause OR GPL-2.0-only
#

obj-$(CONFIG_ARCH_OR1K) += or1k/

=== common/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright © 2017-2021 The Crust Firmware Authors.
+# Copyright © 2017-2022 The Crust Firmware Authors.
 # SPDX-License-Identifier: BSD-3-Clause OR GPL-2.0-only
 #

=== drivers/Makefile ===
--- 
+++ 
@@ -1,11 +1,12 @@
 #
-# Copyright © 2017-2021 The Crust Firmware Authors.
+# Copyright © 2017-2022 The Crust Firmware Authors.
 # SPDX-License-Identifier: BSD-3-Clause OR GPL-2.0-only
 #
 
 obj-$(CONFIG_CEC) += cec/
 obj-$(CONFIG_CIR) += cir/
 obj-y += clock/
+obj-y += counter/
 obj-y += css/
 obj-y += dram/
 obj-y += gpio/

=== lib/Makefile ===
#
# Copyright © 2017-2022 The Crust Firmware Authors.
# SPDX-License-Identifier: BSD-3-Clause OR GPL-2.0-only
#

lib-y += bitfield.o

=== tools/Makefile ===
#
# Copyright © 2017-2022 The Crust Firmware Authors.
# SPDX-License-Identifier: BSD-3-Clause OR GPL-2.0-only
#

tools-y += load
tools-y += test

=== 3rdparty/kconfig/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright © 2017-2021 The Crust Firmware Authors.
+# Copyright © 2017-2022 The Crust Firmware Authors.
 # SPDX-License-Identifier: GPL-2.0-only
 #
 # Based in part on scripts/kconfig/Makefile from Linux v4.19.

=== arch/or1k/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright © 2020-2021 The Crust Firmware Authors.
+# Copyright © 2020-2022 The Crust Firmware Authors.
 # SPDX-License-Identifier: BSD-3-Clause OR GPL-2.0-only
 #

=== common/debug/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright © 2020-2021 The Crust Firmware Authors.
+# Copyright © 2020-2022 The Crust Firmware Authors.
 # SPDX-License-Identifier: BSD-3-Clause OR GPL-2.0-only
 #

=== drivers/cec/Makefile ===
#
# Copyright © 2021-2022 The Crust Firmware Authors.
# SPDX-License-Identifier: BSD-3-Clause OR GPL-2.0-only
#

obj-y += cec.o

obj-y += dw-hdmi-cec.o

=== drivers/cir/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright © 2020-2021 The Crust Firmware Authors.
+# Copyright © 2020-2022 The Crust Firmware Authors.
 # SPDX-License-Identifier: BSD-3-Clause OR GPL-2.0-only
 #

=== debian/changelog ===
crust-firmware (0.6-3) unstable; urgency=medium

  * Prefix debhelper auxiliary file with package name.
  * Build binaries with the desired name instead of renaming them later.
  * debputy.manifest: remove unnecessary quotes.
  * Fix regular expression in watch file.

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 29 Oct 2025 11:37:46 +0100

crust-firmware (0.6-2) unstable; urgency=medium

  * Enable salsa continuous integration
  * Tell gbp-clone to also clone upstream history
  * Drop obsolete Rules-Requires-Root control field
  * Update watch file to format version 5
  * Delegate install steps to debputy

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 14 Oct 2025 00:56:22 +0000

crust-firmware (0.6-1) unstable; urgency=medium

  * New upstream release.
    Remove applied patches and now redundant documentation.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 02 Sep 2023 15:21:32 +0000

crust-firmware (0.5.1.20230301-1) unstable; urgency=medium

  [ Jonas Smedegaard ]
  * fix source helper tool copyright-check:
    + adjust to work with newer Path::Tiny 0.144
    + avoid insecure shell expansion
  * update copyright info: update coverage

  [ Nicolas Boulenguez ]
  * Detect duplicate defconfigs, make new defconfigs easyer to forward
  * New upstream snapshot based on commit c308a504.
    Refresh README.Debian, copyright and patches.
  * Remove teres_i until there is a tester again
  * Forward patches

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 31 Aug 2023 15:35:24 +0000

=== debian/control ===
--- 
+++ 
@@ -5,13 +5,15 @@
 Uploaders:
  Jonas Smedegaard <dr@jones.dk>,
  Arnaud Ferraris <arnaud.ferraris@gmail.com>,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Build-Depends:
  bison,
  debhelper-compat (= 13),
+ dh-sequence-zz-debputy,
  flex,
  gcc-or1k-elf,
-Rules-Requires-Root: no
+ python3,
+ python3-yaml,
 Homepage: https://github.com/crust-firmware/crust
 Vcs-Browser: https://salsa.debian.org/debian/crust-firmware
 Vcs-Git: https://salsa.debian.org/debian/crust-firmware.git
@@ -19,7 +21,6 @@
 Package: crust-firmware
 Architecture: all
 Multi-Arch: foreign
-Depends: ${misc:Depends}
 Description: SCP firmware for Allwinner sunxi boards
  Some System on a Chip (SoC) computers, also known as single-board,
  embed a dedicated processor called a System Control Processor (SCP)

=== debian/rules ===
#!/usr/bin/make -f

verbose := $(if $(filter terse,$(DEB_BUILD_OPTIONS)),,V=1)

%:
	dh $@

# The upstream build system is designed for people building only the
# platform matching their hardware.
# Debian wants to support several platforms, but build and install
# only one representant per defconfig.
# The supported platforms and their testers are listed in
# debian/deputy.manifest.
# The following list contains the actually built platforms.
platforms := $(shell python3 debian/rules.py)

override_dh_auto_build: $(platforms)
$(platforms):
	dh_auto_build -- $(verbose) TGT=build/$@ $@_defconfig
	dh_auto_build -- $(verbose) TGT=build/$@ CROSS_COMPILE=or1k-elf- \
	  build/$@/$@.bin

=== debian/watch ===
Version: 5
# check: uscan --report
# update: see debian/gbp.conf

Dversion-Mangle: auto
Source: https://github.com/crust-firmware/crust/tags
